<template>
  <v-app>
    <!-- BEGIN Menu --><!-- TODO: Make it work -->
    <v-app-bar
      app
      dark
    >

      <!-- <v-app-bar-nav-icon @click.stop="drawer = !drawer"></v-app-bar-nav-icon> -->

      <v-toolbar-title>Vigil</v-toolbar-title>

      <v-spacer></v-spacer>

      <v-btn icon>
        <v-icon>fas fa-bell</v-icon>
      </v-btn>

      <v-btn icon to="user">
        <v-icon>fas fa-user-alt</v-icon>
      </v-btn>

      <v-btn icon @click.stop="logout">
        <v-icon>fas fa-sign-out-alt</v-icon>
      </v-btn>
      
    </v-app-bar>

    <!-- <v-navigation-drawer
      v-model="drawer"
      dark
      absolute
      temporary
    >

      <v-list
        nav
        dense
      >

        <v-list-item>
          <v-list-item-title>Visualisation des Services</v-list-item-title>
        </v-list-item>

        <v-list-item>
          <v-list-item-title>Visualisation des Sondes</v-list-item-title>
        </v-list-item>

        <v-list-item>
          <v-list-item-title>Administration</v-list-item-title>
        </v-list-item>

      </v-list>

    </v-navigation-drawer> -->
    <!-- END Menu -->

    <!-- BEGIN Main content -->
    <v-content>

      <!-- BEGIN Dropdown button -->
      <v-menu bottom offset-y>
        <template v-slot:activator="{ on }">
          <v-btn
          color="primary"
          dark
          v-on="on"
          class="ma-3"
          >
            {{ $t("add-import") }}
          </v-btn>
        </template>

        <v-list>
          <v-list-item @click="openModal('createService')">
            <v-list-item-title>{{ $t("add-service") }}</v-list-item-title>
          </v-list-item>

          <v-list-item @click="$refs.filePickerCsv.click()">
            <input accept=".csv" type="file" ref="filePickerCsv" style="display: none" @change="loadCSV">
            <v-list-item-title>{{ $t("import-csv") }}</v-list-item-title>
          </v-list-item>

          <v-list-item @click="openModal('importNmap')">
            <v-list-item-title>{{ $t("import-nmap") }}</v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>
      <!-- END Dropdown button -->

      <!-- BEGIN -->
      <v-card
      class="ma-3"
      outlined
      >
        <v-card-title>
          {{counters.up + counters.down + counters.ignored }} Services

          <v-spacer></v-spacer>

          <v-btn color="green" dark depressed class="mx-2">{{ counters.up }} {{ $t("up") }}</v-btn>
          <v-btn color="red" dark depressed class="mx-2">{{ counters.down }} {{ $t("down") }}</v-btn>
          <v-btn color="grey" dark depressed class="mx-2">{{ counters.ignored }} {{ $t("ignored") }}</v-btn>

          <v-spacer></v-spacer>

          <!-- <v-btn icon class="mx-1">
            <v-icon color="primary">fas fa-sort-amount-down</v-icon>
          </v-btn>

          <v-btn icon class="mx-1">
            <v-icon color="primary">fas fa-filter</v-icon>
          </v-btn> -->
        </v-card-title>
      </v-card>
      <!-- END -->

      <!-- BEGIN SERVICES LIST -->
      <ListServices @counter="updateCounter" ref="listService"/>
      <!-- END SERVICES LIST -->

      <!-- BEGIN MODAL WINDOWS -->
      <v-dialog v-model="createService.modal" persistent max-width="50vw">
          <CreateService :isUpdate="isAnUpdate" :title="$t('add-service')" :cancelButton="$t('cancel')" :addOrUpdate="$t('add')" @exit="closeModal" @refresh="refreshList"/>
      </v-dialog>
      <v-dialog v-model="importNmap.modal" persistent max-width="50vw">
          <ImportNMAP @exit="closeModal" />
      </v-dialog>
      <!-- END MODAL WINDOWS -->  

    </v-content>
    <!-- END Main content -->
  </v-app>
</template>

<script>
    import CreateService from "@/components/services/CreateService";
    import ImportNMAP from "@/components/services/ImportNMAP";
    import ListServices from "@/components/services/ListServices";

    import APIService from "@/api/ServicesAPI.js";
    const apiService = new APIService();

    export default {
        name: "App",

        components: {
            CreateService,
            ListServices,
            ImportNMAP,
        },

        data () {
            return {
                drawer: null,
                createService: {
                    modal: false,
                },
                importNmap: {
                    modal: false,
                },
                counters: {
                    up: 0,
                    down: 0,
                    ignored: 0,
                },
                isAnUpdate: false,
            };
        },

        watch: {
            /**
             * TODO: JS Doc
             */
            group () {
                this.drawer = false;
            },
        },

        methods: {
            /**
             * Open a modal window
             */
            openModal(modal) {
                this[modal].modal = true;
                console.log(`Modal window opened : ${modal}`);
            },
            
            /**
             * Close a modal window
             */
            closeModal(modal) {
                this[modal].modal = false;
                console.log(`Modal window closed : ${modal}`);
                if(modal === "importNmap") {
                    this.refreshList();
                }
            },

            /**
             * Import CSV file
             */
            loadCSV() {
                try {
                    const file = this.$refs.filePickerCsv.files[0];
                    console.log(file);
                    
                    const reader = new FileReader();
                    reader.readAsText(file);
                    reader.onload = async (e) => {
                        let text = e.target.result;
                        let result = await apiService.importServiceCSV({csv: text});
                        console.log(result);
                        this.$noty.success(this.$t("service-imported"));
                        console.log(this.$refs);
                        await this.$refs.listService.getServices();
                    };
                } catch (error) {
                    console.log("An error has occured :", error);
                }
            },

            /**
             * Update counters
             * @param {Array<Number>} counters [up, down, ignored] counters
             */
            updateCounter(counters) {
                this.counters.up = counters[0];
                this.counters.down = counters[1];
                this.counters.ignored = counters[2];
            },

            /**
             * Refresh the list of services
             */
            refreshList() {
                this.$refs.listService.getServices();
            },

            /**
             * Logout a user
             */
            logout() {
                localStorage.clear();
                this.$router.push("/login");
            },
        },
    };
</script>

<i18n>
{
    "en": {
        "service-imported": "CSV Imported !",
        "add-import": "Add/Import",
        "add-service": "Add a service",
        "import-csv": "Import CSV",
        "import-nmap": "Import NMAP",
        "add": "Add"
    },
    "fr": {
        "service-imported": "CSV importé !",
        "add-import": "Ajouter/Importer",
        "add-service": "Ajouter un service",
        "import-csv": "Importer CSV",
        "import-nmap": "Importer NMAP",
        "add": "Ajouter"
    }
}
</i18n>